<!DOCTYPE html>
<html lang="en">

<head>
    <meta charset="UTF-8">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <title>Update User</title>
    <link rel="stylesheet" href="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/css/bootstrap.min.css">
    <script src="https://ajax.googleapis.com/ajax/libs/jquery/3.7.0/jquery.min.js"></script>
    <script src="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/js/bootstrap.min.js"></script>
</head>

<body>
    <div class="container jumbotron">
        <div class="text center mb-4">
            <h2>Chi tiết User</h2>
        </div>
        <div class="form-group row">
            <label for="inputFirstname" class="col-sm-4 col-form-label">First name</label>
            <div class="col-sm-8">
                <input type="firstname" class="form-control" id="input-firstname">
            </div>
        </div>
        <div class="form-group row">
            <label for="inputLastname" class="col-sm-4 col-form-label">Last name</label>
            <div class="col-sm-8">
                <input type="lastname" class="form-control" id="input-lastname">
            </div>
        </div>
        <div class="form-group row">
            <label for="inputSubject" class="col-sm-4 col-form-label">Subject</label>
            <div class="col-sm-8">
                <input type="subject" class="form-control" id="input-subject">
            </div>
        </div>
        <div class="form-group row">
            <label for="countrySelect" class="col-sm-4 col-form-label">Country</label>
            <div class="col-sm-8">
                <select class="form-control" id="country-select" name="customerType">
                    <option value="VN">Việt Nam</option>
                    <option value="USA">USA</option>
                    <option value="AUS">Australia</option>
                    <option value="CAN">Canada</option>
                </select>
            </div>
        </div>
        <div class="form-group row">
            <label for="customerSelect" class="col-sm-4 col-form-label">Customer Type</label>
            <div class="col-sm-8">
                <select class="form-control" id="customer-type-select" name="customerType">
                    <option value="Standard">Standard</option>
                    <option value="Gold">Gold</option>
                    <option value="Premium">Premium</option>
                </select>
            </div>
        </div>
        <div class="form-group row">
            <label for="registerSelect" class="col-sm-4 col-form-label">Register Status</label>
            <div class="col-sm-8">
                <select class="form-control" id="register-status-select" name="customerType">
                    <option value="New">New</option>
                    <option value="Accepted">Accepted</option>
                    <option value="Denied">Denied</option>
                </select>
            </div>
        </div>
        <div class="form-group row">
            <div class="col-sm-6">
                <button type="button" class="btn btn-success" id="btn-update-user">Update user</button>
            </div>
            <div class="col-sm-6 ">
                <button type="button" class="btn btn-success" id="btn-cancel">Hủy bỏ</button>
            </div>
        </div>
    </div>
</body>
<script>
    "use strict";
    /*** REGION 1 - Global variables - Vùng khai báo biến, hằng số, tham số TOÀN CỤC */
    const gREQUEST_STATUS_OK = 200;
    const gREQUEST_READY_STATUS_FINISH_AND_OK = 4;
    const gREQUEST_STATUS_CREATE_OK = 201;
    const gREQUEST_STATUS_DELETE_OK = 204;
    const gBASE_URL = "http://203.171.20.210:8080/crud-api/users/";

    /*** REGION 2 - Vùng gán / thực thi sự kiện cho các elements */
    $(document).ready(function () {
        onPageLoading();
    })

    //Xử lý nút Update
    $("#btn-update-user").on("click", function () {
        //khai báo đối tượng
        var vDataObj = {
            firstname: "",
            lastname: "",
            subject: "",
            country: "",
            customerType: "",
            registerStatus: "",
        }
        //1.Thu thập dữ liệu
        thuThapData(vDataObj);
        //2.Validate
        var vDuLieuHopLe = kiemTraData(vDataObj);
        if (vDuLieuHopLe) {
            //3.Gọi API
            goiAPIUpdateData();
        }
    });
    /*** REGION 3 - Event handlers - Vùng khai báo các hàm xử lý sự kiện */
    function onPageLoading() {
        //Gọi API
        callAPI();
    }
    /*** REGION 4 - Common funtions - Vùng khai báo hàm dùng chung trong toàn bộ chương trình*/
    //Hàm gọi API
    function callAPI() {
        var vId = "180914";
        $.ajax({
            url: "http://203.171.20.210:8080/crud-api/users/" + vId,
            type: "GET",
            success: function (paramUser) {
                loadUserData(paramUser);
            },
            error: function (paramError) {
                console.log(paramError.status);
            }
        });
    }
    //Hàm load data vào bảng
    function loadUserData(paramUser) {
        var vFirstnameInput = $("#input-firstname");
        var vLastnameInput = $("#input-lastname");
        var vSubjectInput = $("#input-subject");
        var vCountrySelect = $("#country-select");
        var vCustomerSelect = $("#customer-type-select");
        var vRegisterSelect = $("#register-status-select");
        vFirstnameInput.val(paramUser.firstname);
        vLastnameInput.val(paramUser.lastname);
        vSubjectInput.val(paramUser.subject);
        vCountrySelect.val(paramUser.country);
        vCustomerSelect.val(paramUser.customerType);
        vRegisterSelect.val(paramUser.registerStatus);
    }

    //Hàm thu thập dữ liệu
    function thuThapData(vUpdateUserObj) {
        var vFirstnameInput = $("#input-firstname");
        var vLastnameInput = $("#input-lastname");
        var vSubjectInput = $("#input-subject");
        var vCountrySelect = $("#country-select");
        var vCustomerSelect = $("#customer-type-select");
        var vRegisterSelect = $("#register-status-select");
        vUpdateUserObj.firstname = vFirstnameInput.val();
        vUpdateUserObj.lastname = vLastnameInput.val();
        vUpdateUserObj.subject = vSubjectInput.val();
        vUpdateUserObj.country = vCountrySelect.val();
        vUpdateUserObj.customerType = vCustomerSelect.val();
        vUpdateUserObj.registerStatus = vRegisterSelect.val();
    }
    //Hàm validate
    function kiemTraData(paramUserObj) {
        if (paramUserObj.firstname == "") {
            alert("Bạn chưa nhập First name");
            return false;
        }
        if (paramUserObj.lastname == "") {
            alert("Bạn chưa nhập Last name");
            return false;
        }
        if (paramUserObj.subject == "") {
            alert("Bạn chưa nhập Subject");
            return false;
        }
        if (paramUserObj.country == "") {
            alert("Bạn chưa nhập country");
            return false;
        }
        if (paramUserObj.customerType == "") {
            alert("Bạn chưa nhập Customer type");
            return false;
        }
        if (paramUserObj.registerStatus == "") {
            alert("Bạn chưa nhập register");
            return false;
        }
        return true;
    }
    //Hàm gọi API
    function goiAPIUpdateData() {
        //Lấy dữ liệu User dựa vào UserId
        var vUserId = "180912";
        //data to be sent 
        var vObjectRequestData = {
            firstname: "Mike",
            lastname: "Donasky",
            subject: "On business 200",
            country: "USA",
            customerType: "Gold",
            registerStatus: "New"
        };
        //Gọi API
        $.ajax({
            url: gBASE_URL + vUserId,
            type: "PUT",
            contentType: "application/json",
            data: JSON.stringify(vObjectRequestData),
            success: function (responseObj) {
                alert("User ID: " + responseObj.id);
                console.log(responseObj);
                window.location.href = "listUsers.html";
                console.log(JSON.stringify(responseObj, true, 2));
            },
            error: function (paramError) {
                alert(paramError.responseText);
            }
        });
    }
</script>

</html>